# ChunkCodecLibLz4

## Warning: ChunkCodecLibLz4 is currently a WIP and its API may drastically change at any time.

This package implements the ChunkCodec interface for the following encoders and decoders
using the lz4 C library <https://lz4.org/>

1. `LZ4FrameCodec`, `LZ4FrameEncodeOptions`, `LZ4FrameDecodeOptions`
1. `LZ4BlockCodec`, `LZ4BlockEncodeOptions`, `LZ4BlockDecodeOptions`
1. `LZ4NumcodecsCodec`, `LZ4NumcodecsEncodeOptions`, `LZ4NumcodecsDecodeOptions`

## Example

```julia-repl
julia> using ChunkCodecLibLz4

julia> data = [0x00, 0x01, 0x02, 0x03];

julia> compressed_data = encode(LZ4FrameEncodeOptions(;compressionLevel=3), data);

julia> decompressed_data = decode(LZ4FrameCodec(), compressed_data; max_size=length(data), size_hint=length(data));

julia> data == decompressed_data
true
```

The low level interface is defined in the `ChunkCodecCore` package.

# Constants and c wrapper functions ported to Julia from lz4frame.h
# https://github.com/lz4/lz4/blob/v1.10.0/lib/lz4frame.h

const LZ4F_VERSION = Cuint(100) # This number can be used to check for an incompatible API breaking change
LZ4F_getVersion()::Cuint = ccall((:LZ4F_getVersion, liblz4), Cuint, ())

"""
    LZ4F_isError(ret::Csize_t)::Bool

Return true if return `ret` is an error
"""
function LZ4F_isError(ret::Csize_t)::Bool
    !iszero(ccall((:LZ4F_isError, liblz4), Cuint, (Csize_t,), ret))
end

# provides readable string from a function result
function LZ4F_getErrorName(ret::Csize_t)::String
    unsafe_string(ccall((:LZ4F_getErrorName, liblz4), Ptr{Cchar}, (Csize_t,), ret))
end

# The larger the block size, the (slightly) better the compression ratio,
# though there are diminishing returns.
# Larger blocks also increase memory usage on both compression and decompression sides.
@enum LZ4F_blockSizeID_t::Cint begin
    LZ4F_default=0
    LZ4F_max64KB=4
    LZ4F_max256KB=5
    LZ4F_max1MB=6
    LZ4F_max4MB=7
end

# Linked blocks sharply reduce inefficiencies when using small blocks,
# they compress better.
# However, some LZ4 decoders are only compatible with independent blocks
@enum LZ4F_blockMode_t::Cint begin
    LZ4F_blockLinked=0
    LZ4F_blockIndependent
end

@enum LZ4F_contentChecksum_t::Cint begin
    LZ4F_noContentChecksum=0
    LZ4F_contentChecksumEnabled
end

@enum LZ4F_blockChecksum_t::Cint begin
    LZ4F_noBlockChecksum=0
    LZ4F_blockChecksumEnabled
end

@enum LZ4F_frameType_t::Cint begin
    LZ4F_frame=0
    LZ4F_skippableFrame
end

"""
    LZ4F_frameInfo_t

makes it possible to set or read frame parameters.
Structure must be first init to 0, using memset() or LZ4F_INIT_FRAMEINFO,
setting all parameters to default.
It's then possible to update selectively some parameters
"""
struct LZ4F_frameInfo_t
    "max64KB, max256KB, max1MB, max4MB; 0 == default (LZ4F_max64KB)"
    blockSizeID::LZ4F_blockSizeID_t

    "LZ4F_blockLinked, LZ4F_blockIndependent; 0 == default (LZ4F_blockLinked)"
    blockMode::LZ4F_blockMode_t

    "1: add a 32-bit checksum of frame's decompressed data; 0 == default (disabled)"
    contentChecksumFlag::LZ4F_contentChecksum_t

    "read-only field : LZ4F_frame or LZ4F_skippableFrame"
    frameType::LZ4F_frameType_t

    "Size of uncompressed content ; 0 == unknown"
    contentSize::Culonglong

    "Dictionary ID, sent by compressor to help decoder select correct dictionary; 0 == no dictID provided"
    dictID::Cuint

    "1: each block followed by a checksum of block's compressed data; 0 == default (disabled)"
    blockChecksumFlag::LZ4F_blockChecksum_t
end

const LZ4F_INIT_FRAMEINFO = LZ4F_frameInfo_t(LZ4F_max64KB, LZ4F_blockLinked, LZ4F_noContentChecksum, LZ4F_frame, Culonglong(0), Cuint(0), LZ4F_noBlockChecksum)

"""
    LZ4F_preferences_t

makes it possible to supply advanced compression instructions to streaming interface.
Structure must be first init to 0, using memset() or LZ4F_INIT_PREFERENCES,
setting all parameters to default.
All reserved fields must be set to zero.
"""
struct LZ4F_preferences_t
    frameInfo::LZ4F_frameInfo_t

    "0: default (fast mode); values > LZ4HC_CLEVEL_MAX count as LZ4HC_CLEVEL_MAX; values < 0 trigger fast acceleration"
    compressionLevel::Cint

    "1: always flush; reduces usage of internal buffers"
    autoFlush::Cuint

    "1: parser favors decompression speed vs compression ratio. Only works for high compression modes (>= LZ4HC_CLEVEL_OPT_MIN)   v1.8.2+ "
    favorDecSpeed::Cuint

    # must be zero for forward compatibility
    reserved::NTuple{3, Cuint}
end

const LZ4F_INIT_PREFERENCES = LZ4F_preferences_t(LZ4F_INIT_FRAMEINFO, Cint(0), Cuint(0), Cuint(0), (Cuint(0), Cuint(0), Cuint(0)))    # /* v1.8.3+ */

#  LZ4F_compressFrame() :
#  Compress srcBuffer content into an LZ4-compressed frame.
#  It's a one shot operation, all input content is consumed, and all output is generated.
#
#  Note : it's a stateless operation (no LZ4F_cctx state needed).
#  In order to reduce load on the allocator, LZ4F_compressFrame(), by default,
#  uses the stack to allocate space for the compression state and some table.
#  If this usage of the stack is too much for your application,
#  consider compiling `lz4frame.c` with compile-time macro LZ4F_HEAPMODE set to 1 instead.
#  All state allocations will use the Heap.
#  It also means each invocation of LZ4F_compressFrame() will trigger several internal alloc/free invocations.
#
# @dstCapacity MUST be >= LZ4F_compressFrameBound(srcSize, preferencesPtr).
# @preferencesPtr is optional : one can provide NULL, in which case all preferences are set to default.
# @return : number of bytes written into dstBuffer.
#           or an error code if it fails (can be tested using LZ4F_isError())
# 
function LZ4F_compressFrame(
        dst::AbstractVector{UInt8},
        src::AbstractVector{UInt8},
        preferences::LZ4F_preferences_t,
    )::Csize_t
    ccall(
        (:LZ4F_compressFrame, liblz4), Csize_t,
        (Ptr{UInt8}, Csize_t, Ptr{UInt8}, Csize_t, Ref{LZ4F_preferences_t}),
        dst, length(dst), src, length(src), Ref(preferences),
    )
end

# /*! LZ4F_compressFrameBound() :
#  *  Returns the maximum possible compressed size with LZ4F_compressFrame() given srcSize and preferences.
#  * `preferencesPtr` is optional. It can be replaced by NULL, in which case, the function will assume default preferences.
#  *  Note : this result is only usable with LZ4F_compressFrame().
#  *         It may also be relevant to LZ4F_compressUpdate() _only if_ no flush() operation is ever performed.
#  */
# If Csize_t is 64 bits, to be safe, a srcSize less than 2^47-2 doesn't overflow
# If Csize_t is 32 bits, to be safe, a srcSize less than 2^31-2 doesn't overflow
function LZ4F_compressFrameBound(srcSize::Csize_t, preferences::LZ4F_preferences_t,)::Csize_t
    ccall(
        (:LZ4F_compressFrameBound, liblz4), Csize_t,
        (Csize_t, Ref{LZ4F_preferences_t}),
        srcSize, Ref(preferences),
    )
end


# Just used to mark the type of pointers
mutable struct LZ4F_dctx end

struct LZ4F_decompressOptions_t
    """
    pledges that last 64KB decompressed data is present right before @dstBuffer pointer.
    This optimization skips internal storage operations.
    Once set, this pledge must remain valid up to the end of current frame.
    """
    stableDst::Cuint

    """
    disable checksum calculation and verification, even when one is present in frame, to save CPU time.
    Setting this option to 1 once disables all checksums for the rest of the frame.
    """
    skipChecksums::Cuint

    reserved1::Cuint # must be set to zero for forward compatibility
    reserved0::Cuint # idem
end

function LZ4F_createDecompressionContext()::Ptr{LZ4F_dctx}
    dctxPtr = Ref(Ptr{LZ4F_dctx}())
    ret = ccall(
        (:LZ4F_createDecompressionContext, liblz4), Csize_t,
        (Ref{Ptr{LZ4F_dctx}}, Cuint),
        dctxPtr, LZ4F_VERSION,
    )
    if LZ4F_isError(ret)
        throw(OutOfMemoryError())
    else
        dctxPtr[]
    end
end
function LZ4F_freeDecompressionContext(dctx::Ptr{LZ4F_dctx})::Nothing
    ccall(
        (:LZ4F_freeDecompressionContext, liblz4), Csize_t,
        (Ptr{LZ4F_dctx},),
        dctx,
    )
    # ignore errors
    nothing
end



# The following is the original license info from lz4frame.h

#=
   LZ4F - LZ4-Frame library
   Header File
   Copyright (C) 2011-2020, Yann Collet.
   BSD 2-Clause License (http://www.opensource.org/licenses/bsd-license.php)

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
       * Redistributions in binary form must reproduce the above
   copyright notice, this list of conditions and the following disclaimer
   in the documentation and/or other materials provided with the
   distribution.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

   You can contact the author at :
   - LZ4 source repository : https://github.com/lz4/lz4
   - LZ4 public forum : https://groups.google.com/forum/#!forum/lz4c
=#

using ChunkCodecCore: try_encode!, try_find_decoded_size, encode, decode, is_size
using ChunkCodecLibLz4
using ChunkCodecTests: test_codec
using Test: @testset, @test_throws, @test

@testset "default" begin
    test_codec(LZ4HDF5Codec(), LZ4HDF5EncodeOptions(), LZ4HDF5DecodeOptions(); trials=1000)
end
@testset "compressionLevel options" begin
    # Compression level is clamped
    for compressionLevel in [typemin(Int128); -30:13; typemax(Int128)]
        test_codec(
            LZ4HDF5Codec(),
            LZ4HDF5EncodeOptions(; compressionLevel),
            LZ4HDF5DecodeOptions();
            trials=3,
        )
    end
end
@testset "blockSize options" begin
    # out of range options
    for blockSize in Any[0, -1, typemin(Int32), ChunkCodecLibLz4.LZ4_MAX_INPUT_SIZE+1, Int64(2)^32]
        @test_throws ArgumentError LZ4HDF5EncodeOptions(;blockSize)
    end
    for blockSize in [1:6; 2^10; 2^20; 2^30; ChunkCodecLibLz4.LZ4_MAX_INPUT_SIZE;]
        test_codec(
            LZ4HDF5Codec(),
            LZ4HDF5EncodeOptions(; blockSize),
            LZ4HDF5DecodeOptions();
            trials=10,
        )
    end
end
@testset "unexpected eof" begin
    for blockSize in (1,2,5,999,1000,1001,10000)
        e = LZ4HDF5EncodeOptions(;blockSize)
        d = LZ4HDF5DecodeOptions()
        u = rand(UInt8, 1000)
        c = encode(e, u)
        @test decode(d, c) == u
        for i in 1:length(c)
            @test_throws LZ4DecodingError decode(d, c[1:i-1])
        end
        @test_throws LZ4DecodingError decode(d, [c; c;])
        @test_throws LZ4DecodingError decode(d, [c; 0x00;])
    end
end
@testset "decoding errors" begin
    e = LZ4HDF5EncodeOptions()
    d = LZ4HDF5DecodeOptions()
    # less than 12 bytes
    @test_throws LZ4DecodingError("unexpected end of input") try_find_decoded_size(d, UInt8[])
    @test_throws LZ4DecodingError("decoded size is negative") try_find_decoded_size(d, fill(0xFF,12))
    @test typemax(Int64) == try_find_decoded_size(d, [0x7F; fill(0xFF, 11);])
    # invalid block size
    @test_throws LZ4DecodingError("block size must be greater than zero") decode(d, [
        reinterpret(UInt8, [hton(Int64(0))]);
        reinterpret(UInt8, [hton(Int32(-1))]);
    ])
    @test_throws LZ4DecodingError("block size must be greater than zero") decode(d, [
        reinterpret(UInt8, [hton(Int64(0))]);
        reinterpret(UInt8, [hton(Int32(0))]);
    ])
    @test_throws LZ4DecodingError("unexpected $(1) bytes after stream") decode(d, [
        reinterpret(UInt8, [hton(Int64(0))]);
        reinterpret(UInt8, [hton(Int32(1))]);
        0x00;
    ])
    @test_throws LZ4DecodingError("unexpected end of input") decode(d, [
        reinterpret(UInt8, [hton(Int64(1))]);
        reinterpret(UInt8, [hton(Int32(16))]);
    ])
    @test_throws LZ4DecodingError("block compressed size must be greater than zero") decode(d, [
        reinterpret(UInt8, [hton(Int64(1))]);
        reinterpret(UInt8, [hton(Int32(16))]);
        reinterpret(UInt8, [hton(Int32(0))]);
    ])
    @test_throws LZ4DecodingError("unexpected end of input") decode(d, [
        reinterpret(UInt8, [hton(Int64(1))]);
        reinterpret(UInt8, [hton(Int32(16))]);
        reinterpret(UInt8, [hton(Int32(16))]);
    ])
    # edge case where decoded size is greater than block size
    # in this case decode with lz4 block
    @test [0x12, 0x34] == decode(d, [
        reinterpret(UInt8, [hton(Int64(2))]);
        reinterpret(UInt8, [hton(Int32(16))]);
        reinterpret(UInt8, [hton(Int32(3))]);
        [0x20, 0x12, 0x34];
    ])
    @test_throws LZ4DecodingError("src is malformed") decode(d, [
        reinterpret(UInt8, [hton(Int64(2))]);
        reinterpret(UInt8, [hton(Int32(16))]);
        reinterpret(UInt8, [hton(Int32(3))]);
        [0x30, 0x12, 0x34];
    ])
    @test_throws LZ4DecodingError("saved decoded size is not correct") decode(d, [
        reinterpret(UInt8, [hton(Int64(16))]);
        reinterpret(UInt8, [hton(Int32(16))]);
        reinterpret(UInt8, [hton(Int32(3))]);
        [0x20, 0x12, 0x34];
    ])
    @test_throws LZ4DecodingError("unexpected end of input") decode(d, [
        reinterpret(UInt8, [hton(Int64(3))]);
        reinterpret(UInt8, [hton(Int32(16))]);
        reinterpret(UInt8, [hton(Int32(3))]);
        [0x20, 0x12,];
    ])
end
@testset "encoding without enough space" begin
    e = LZ4HDF5EncodeOptions(; blockSize=32)
    d = LZ4HDF5DecodeOptions()
    u = rand(UInt8, 1024)
    c = zeros(UInt8, 1024+12+32*4)
    @test Int64(try_encode!(e, c, u)) == length(c)
    @test decode(d, c) == u
    for i in 1:length(c)
        @test !is_size(try_encode!(e, c[1:i-1], u))
    end
    # zero length
    u = UInt8[]
    c = zeros(UInt8, 12)
    @test Int64(try_encode!(e, c, u)) == length(c)
    @test decode(d, c) == u
    for i in 1:length(c)
        @test !is_size(try_encode!(e, c[1:i-1], u))
    end
    # one length
    u = UInt8[0x00]
    c = zeros(UInt8, 12+5)
    @test Int64(try_encode!(e, c, u)) == length(c)
    @test decode(d, c) == u
    for i in 1:length(c)
        @test !is_size(try_encode!(e, c[1:i-1], u))
    end
end

using ChunkCodecCore: encode_bound, decoded_size_range, encode, decode
using ChunkCodecLibLz4
using ChunkCodecTests: test_codec
using Test: @testset, @test_throws, @test

@testset "default" begin
    test_codec(LZ4FrameCodec(), LZ4FrameEncodeOptions(), LZ4FrameDecodeOptions(); trials=100)
end
@testset "compressionLevel options" begin
    # Compression level is clamped
    for favorDecSpeed in (false,true)
        for compressionLevel in [typemin(Int128); -30:13; typemax(Int128)]
            test_codec(
                LZ4FrameCodec(),
                LZ4FrameEncodeOptions(; compressionLevel, favorDecSpeed),
                LZ4FrameDecodeOptions();
                trials=3,
            )
        end
    end
end
@testset "blockSizeID and blockMode options" begin
    @test_throws ArgumentError LZ4FrameEncodeOptions(; blockSizeID=1000)
    @test_throws ArgumentError LZ4FrameEncodeOptions(; blockSizeID=3)
    @test_throws ArgumentError LZ4FrameEncodeOptions(; blockSizeID=-1)
    for blockMode in (false, true)
        for blockSizeID in (0, 4, 5, 6, 7)
            local e = LZ4FrameEncodeOptions(;blockSizeID, blockMode)
            local d = LZ4FrameDecodeOptions()
            test_codec(LZ4FrameCodec(), e, d; trials=3)
            # Encode and decode large amounts to really test this
            local u = rand(UInt8, 2^26)
            local c = encode(e, u)
            @test decode(d, c) == u
            local u = ones(UInt8, 2^26)
            local c = encode(e, u)
            @test decode(d, c) == u
        end
    end
end
@testset "other options" begin
    for contentChecksumFlag in (false, true), contentSize in (false, true), blockChecksumFlag in (false, true)
        local e = LZ4FrameEncodeOptions(;contentChecksumFlag, contentSize, blockChecksumFlag)
        local d = LZ4FrameDecodeOptions()
        test_codec(LZ4FrameCodec(), e, d; trials=3)
        # Encode and decode large amounts to really test this
        local u = rand(UInt8, 2^26)
        local c = encode(e, u)
        @test decode(d, c) == u
        local u = ones(UInt8, 2^26)
        local c = encode(e, u)
        @test decode(d, c) == u
    end
end
@testset "unexpected eof" begin
    e = LZ4FrameEncodeOptions()
    d = LZ4FrameDecodeOptions()
    u = [0x00, 0x01, 0x02]
    c = encode(e, u)
    @test decode(d, c) == u
    for i in 1:length(c)
        @test_throws LZ4DecodingError decode(d, c[1:i-1])
    end
    @test_throws LZ4DecodingError decode(d, u)
    c[2] = 0x00
    @test_throws LZ4DecodingError decode(d, c)
    @test_throws LZ4DecodingError decode(d, [encode(e, u); c])
    @test_throws LZ4DecodingError decode(d, [encode(e, u); 0x00])
    e = LZ4FrameEncodeOptions(;contentChecksumFlag=true)
    c = encode(e, u)
    c[end] ⊻= 0xFF
    # This fails checksum
    @test_throws LZ4DecodingError decode(d, c)
end
@testset "Skippable Frames" begin
    e = LZ4FrameEncodeOptions()
    d = LZ4FrameDecodeOptions()
    u = [0x00, 0x01, 0x02]
    c = [encode(e, u); 0x50; 0x2A; 0x4D; 0x18; 0x00; 0x00; 0x00; 0x00]
    @test decode(d, c) == u
    @test_throws LZ4DecodingError decode(d, c[1:end-1])
    c = [encode(e, u); 0x50; 0x2A; 0x4D; 0x18; 0x01; 0x00; 0x00; 0x00; 0x42]
    @test decode(d, c) == u
    @test_throws LZ4DecodingError decode(d, c[1:end-1])
    @test decode(d, [0x50; 0x2A; 0x4D; 0x18; 0x00; 0x00; 0x00; 0x00]) == UInt8[]
end

"""
    LZ4DecodingError(msg)

Error for data that cannot be decoded.
"""
struct LZ4DecodingError <: DecodingError
    msg::String
end

function Base.showerror(io::IO, err::LZ4DecodingError)
    print(io, "LZ4DecodingError: ")
    print(io, err.msg)
    nothing
end

"""
    struct LZ4FrameDecodeOptions <: DecodeOptions
    LZ4FrameDecodeOptions(; kwargs...)

lz4 frame decompression using liblz4: https://lz4.org/

This is the LZ4 Frame (.lz4) format described in https://github.com/lz4/lz4/blob/v1.10.0/doc/lz4_Frame_format.md

This format is compatible with the `lz4` CLI.

Decoding will succeed even if the decompressed size is unknown.
Decoding accepts concatenated frames 
and will error if there is invalid data appended.

# Keyword Arguments

- `codec::LZ4FrameCodec=LZ4FrameCodec()`
"""
struct LZ4FrameDecodeOptions <: DecodeOptions
    codec::LZ4FrameCodec
end
function LZ4FrameDecodeOptions(;
        codec::LZ4FrameCodec=LZ4FrameCodec(),
        kwargs...
    )
    LZ4FrameDecodeOptions(codec)
end

is_thread_safe(::LZ4FrameDecodeOptions) = true

can_concatenate(::LZ4FrameDecodeOptions) = true

function try_find_decoded_size(::LZ4FrameDecodeOptions, src::AbstractVector{UInt8})::Nothing
    # TODO This might be possible to do using a method similar to ZstdDecodeOptions
    # For now just return nothing
    nothing
end

function try_decode!(d::LZ4FrameDecodeOptions, dst::AbstractVector{UInt8}, src::AbstractVector{UInt8}; kwargs...)::MaybeSize
    try_resize_decode!(d, dst, src, Int64(length(dst)))
end

function try_resize_decode!(d::LZ4FrameDecodeOptions, dst::AbstractVector{UInt8}, src::AbstractVector{UInt8}, max_size::Int64; kwargs...)::MaybeSize
    dst_size::Int64 = length(dst)
    src_size::Int64 = length(src)
    src_left::Int64 = src_size
    dst_left::Int64 = dst_size
    check_contiguous(dst)
    check_contiguous(src)
    cconv_src = Base.cconvert(Ptr{UInt8}, src)
    # This outer loop is to decode a concatenation of multiple compressed frames.
    while true
        dctx = LZ4F_createDecompressionContext()
        try
            while true
                # dst may get resized, so cconvert needs to be redone on each iteration.
                cconv_dst = Base.cconvert(Ptr{UInt8}, dst)
                GC.@preserve cconv_src cconv_dst begin
                    src_p = Base.unsafe_convert(Ptr{UInt8}, cconv_src)
                    dst_p = Base.unsafe_convert(Ptr{UInt8}, cconv_dst)
                    start_avail_in = Csize_t(src_left)
                    start_avail_out = Csize_t(dst_left)
                    srcSizePtr = Ref(start_avail_in)
                    dstSizePtr = Ref(start_avail_out)
                    next_in = src_p + (src_size - src_left)
                    next_out = dst_p + (dst_size - dst_left)
                    # TODO maybe it is safe to set stableDst in LZ4F_decompressOptions_t
                    ret = ccall(
                        (:LZ4F_decompress, liblz4),
                        Csize_t,
                        (Ptr{LZ4F_dctx}, Ptr{UInt8}, Ref{Csize_t}, Ptr{UInt8}, Ref{Csize_t}, Ptr{LZ4F_decompressOptions_t}),
                        dctx, next_out, dstSizePtr, next_in, srcSizePtr, C_NULL,
                    )
                    if !LZ4F_isError(ret)
                        @assert srcSizePtr[] ≤ start_avail_in
                        @assert dstSizePtr[] ≤ start_avail_out
                        Δin = Int64(srcSizePtr[])
                        Δout = Int64(dstSizePtr[])
                        dst_left -= Δout
                        src_left -= Δin
                        @assert src_left ∈ 0:src_size
                        @assert dst_left ∈ 0:dst_size
                        if iszero(ret)
                            # Frame is fully decoded!!!!
                            if iszero(src_left)
                                # yay done return decompressed size
                                real_dst_size = dst_size - dst_left
                                @assert real_dst_size ∈ 0:length(dst)
                                return real_dst_size
                            else
                                # try and decompress next frame
                                # there must be progress
                                @assert Δin > 0 || Δout > 0
                                break
                            end
                        else
                            if iszero(dst_left) # needs more output
                                local next_size = grow_dst!(dst, max_size)
                                if isnothing(next_size)
                                    return NOT_SIZE
                                end
                                dst_left += next_size - dst_size
                                dst_size = next_size
                                @assert dst_left > 0
                            else # needs more input
                                if iszero(src_left)
                                    throw(LZ4DecodingError("unexpected end of stream"))
                                end
                                # there must be progress
                                @assert Δin > 0 || Δout > 0
                            end
                        end
                    else
                        throw(LZ4DecodingError(LZ4F_getErrorName(ret)))
                    end
                end
            end
        finally
            LZ4F_freeDecompressionContext(dctx)
        end
    end
end


"""
    struct LZ4BlockDecodeOptions <: DecodeOptions
    LZ4BlockDecodeOptions(; kwargs...)

lz4 block compression using liblz4: https://lz4.org/

This is the LZ4 Block format described in https://github.com/lz4/lz4/blob/v1.10.0/doc/lz4_Block_format.md

This format has no framing layer and is NOT compatible with the `lz4` CLI.

Decoding requires the encoded size to be at most `typemax(Int32)`.

# Keyword Arguments

- `codec::LZ4BlockCodec=LZ4BlockCodec()`
"""
struct LZ4BlockDecodeOptions <: DecodeOptions
    codec::LZ4BlockCodec
end
function LZ4BlockDecodeOptions(;
        codec::LZ4BlockCodec=LZ4BlockCodec(),
        kwargs...
    )
    LZ4BlockDecodeOptions(codec)
end

is_thread_safe(::LZ4BlockDecodeOptions) = true

# There is no header or footer, so always return nothing
function try_find_decoded_size(::LZ4BlockDecodeOptions, src::AbstractVector{UInt8})::Nothing
    nothing
end

function try_decode!(d::LZ4BlockDecodeOptions, dst::AbstractVector{UInt8}, src::AbstractVector{UInt8}; kwargs...)::MaybeSize
    check_contiguous(dst)
    check_contiguous(src)
    src_size::Int64 = length(src)
    if src_size > typemax(Int32)
        throw(LZ4DecodingError("encoded size is larger than `typemax(Int32)`"))
    end
    src_size32 = src_size%Int32
    dst_size32 = clamp(length(dst), Int32)
    cconv_src = Base.cconvert(Ptr{UInt8}, src)
    cconv_dst = Base.cconvert(Ptr{UInt8}, dst)
    ret = GC.@preserve cconv_src cconv_dst begin
        src_p = Base.unsafe_convert(Ptr{UInt8}, cconv_src)
        dst_p = Base.unsafe_convert(Ptr{UInt8}, cconv_dst)
        unsafe_lz4_decompress(src_p, dst_p, src_size32, dst_size32)
    end
    if signbit(ret)
        # Manually find the decoded size because
        # Otherwise there is no way to tell if malformed or dst is
        # too small :(.
        # This is not done in try_find_decoded_size because it is too slow
        actual_decoded_len = dry_run_block_decode(src)
        if actual_decoded_len ≤ dst_size32
            throw(LZ4DecodingError("unknown LZ4 block decoding error"))
        elseif actual_decoded_len > typemax(Int32)
            throw(LZ4DecodingError("actual decoded size > typemax(Int32): $(actual_decoded_len) > $(typemax(Int32))"))
        else
            # Ok to try again with larger dst
            # We return a hint with the actual decoded len
            return MaybeSize(-actual_decoded_len)
        end
    else
        return Int64(ret)
    end
end

"""
    dry_run_block_decode(src::AbstractVector{UInt8})::Int64

If src is a valid independent lz4 block, return the decoded size. Otherwise throw a
`LZ4DecodingError`.

The `(:LZ4_decompress_safe, liblz4)` c function doesn't allow distinguishing
between different errors. Ref: https://github.com/lz4/lz4/issues/156

This function can be used if `LZ4_decompress_safe` fails to get more information
about a block for error recovery purposes.
"""
function dry_run_block_decode(src::AbstractVector{UInt8})::Int64
    # based on https://github.com/lz4/lz4/blob/dev/doc/lz4_Block_format.md
    src_size::Int64 = length(src)
    @assert !signbit(src_size)
    src_ptr::Int64 = 0
    dst_size::Int64 = 0
    last_match_start::Int64 = -1 # -1 marks first sequence
    while true
        # read token
        if src_ptr > src_size - 1
            throw(LZ4DecodingError("unexpected end of input"))
        end
        local token = src[begin+src_ptr]
        src_ptr += Int64(1)

        # read length of literals
        local h_bits = token >> 4
        local l_bits = token & 0x0F
        local length_of_literals::Int64 = h_bits
        if h_bits == 0x0F
            # The value 15 is a special case: more bytes are required to indicate the full length.
            while true
                if src_ptr > src_size - 1
                    throw(LZ4DecodingError("unexpected end of input"))
                end
                local x = src[begin+src_ptr]
                src_ptr += Int64(1)
                # `length_of_literals` shouldn't overflow unless input size
                # is multiple petabytes
                length_of_literals += Int64(x)
                x == 0xFF || break
            end
        end

        # read literals and end of block checks
        dst_size += length_of_literals
        src_ptr += length_of_literals
        if src_ptr > src_size
            throw(LZ4DecodingError("unexpected end of input"))
        elseif src_ptr == src_size
            # End of block condition 1
            # The last sequence contains only literals. The block ends right after the literals (no offset field).
            if !iszero(l_bits)
                throw(LZ4DecodingError("end of block condition 1 violated"))
            end
            if last_match_start != -1
                # There was a previous match.
                # Check end of block condition 2:
                # The last 5 bytes of input are always literals. Therefore, the last sequence contains at least 5 bytes.
                if length_of_literals < 5
                    throw(LZ4DecodingError("end of block condition 2 violated"))
                end
                # Check end of block condition 3:
                # The last match must start at least 12 bytes before the end of block. The last match is part of the penultimate sequence. It is followed by the last sequence, which contains only literals.
                if last_match_start > dst_size - 12
                    throw(LZ4DecodingError("end of block condition 3 violated"))
                end
                return dst_size
            else
                # No previous match.
                # End of block condition 2 and 3 do not need to be checked
                return dst_size
            end
        end

        # read offset
        if src_ptr > src_size - 2
            throw(LZ4DecodingError("unexpected end of input"))
        end
        local offset::UInt16 = UInt16(src[begin+src_ptr]) | UInt16(src[begin+src_ptr+1])<<8
        src_ptr += Int64(2)
        if iszero(offset)
            # The presence of a 0 offset value denotes an invalid (corrupted) block.
            throw(LZ4DecodingError("zero offset value found"))
        elseif offset > dst_size
            throw(LZ4DecodingError("offset is before the beginning of the output"))
        end
        last_match_start = dst_size

        # read matchlength
        matchlength::Int64 = Int64(l_bits) + Int64(4)
        if l_bits == 0x0F
            while true
                if src_ptr > src_size - 1
                    throw(LZ4DecodingError("unexpected end of input"))
                end
                local x = src[begin+src_ptr]
                src_ptr += Int64(1)
                # `matchlength` shouldn't overflow unless input size
                # is multiple petabytes
                matchlength += Int64(x)
                x == 0xFF || break
            end
        end
        dst_size += matchlength

        # continue to next sequence
    end
end

"""
    struct LZ4NumcodecsDecodeOptions <: DecodeOptions
    LZ4NumcodecsDecodeOptions(; kwargs...)

lz4 numcodecs style compression using liblz4: https://lz4.org/

This is the [`LZ4BlockCodec`](@ref) format with a 4-byte header containing the
size of the decoded data as a little-endian 32-bit signed integer.

This format is documented in https://numcodecs.readthedocs.io/en/stable/compression/lz4.html

This format is NOT compatible with the `lz4` CLI.

Decoding requires the exact encoded size to be known and be no more than `typemax(Int32) + 4`.

# Keyword Arguments

- `codec::LZ4NumcodecsCodec=LZ4NumcodecsCodec()`
"""
struct LZ4NumcodecsDecodeOptions <: DecodeOptions
    codec::LZ4NumcodecsCodec
end
function LZ4NumcodecsDecodeOptions(;
        codec::LZ4NumcodecsCodec=LZ4NumcodecsCodec(),
        kwargs...
    )
    LZ4NumcodecsDecodeOptions(codec)
end

is_thread_safe(::LZ4NumcodecsDecodeOptions) = true

function try_find_decoded_size(::LZ4NumcodecsDecodeOptions, src::AbstractVector{UInt8})::Int64
    if length(src) < 4
        throw(LZ4DecodingError("unexpected end of input"))
    else
        decoded_size = Int32(0)
        for i in 0:3
            decoded_size |= Int32(src[begin+i])<<(i*8)
        end
        if signbit(decoded_size)
            throw(LZ4DecodingError("decoded size is negative"))
        else
            Int64(decoded_size)
        end
    end
end

function try_decode!(d::LZ4NumcodecsDecodeOptions, dst::AbstractVector{UInt8}, src::AbstractVector{UInt8}; kwargs...)::MaybeSize
    check_contiguous(dst)
    check_contiguous(src)
    decoded_size::Int64 = try_find_decoded_size(d, src)
    src_size::Int64 = length(src)
    if src_size-4 > typemax(Int32)
        throw(LZ4DecodingError("encoded size is larger than `typemax(Int32) + 4`"))
    end
    src_size32 = (src_size-4)%Int32
    dst_size::Int64 = length(dst)
    if decoded_size > dst_size
        return NOT_SIZE
    else
        cconv_src = Base.cconvert(Ptr{UInt8}, src)
        cconv_dst = Base.cconvert(Ptr{UInt8}, dst)
        GC.@preserve cconv_src cconv_dst begin
            src_p = Base.unsafe_convert(Ptr{UInt8}, cconv_src)
            dst_p = Base.unsafe_convert(Ptr{UInt8}, cconv_dst)
            # decoded_size must already be ≤ typemax(Int32) from try_find_decoded_size
            ret = unsafe_lz4_decompress(src_p+4, dst_p, src_size32, decoded_size%Int32)
            if signbit(ret)
                throw(LZ4DecodingError("src is malformed"))
            elseif ret != decoded_size
                throw(LZ4DecodingError("saved decoded size is not correct"))
            else
                return Int64(ret)
            end
        end
    end
end


"""
    struct LZ4HDF5DecodeOptions <: DecodeOptions
    LZ4HDF5DecodeOptions(; kwargs...)

LZ4 HDF5 format compression using liblz4: https://lz4.org/

This is the LZ4 HDF5 format used in HDF5 Filter ID: 32004.

This format is documented in https://github.com/HDFGroup/hdf5_plugins

This format is NOT compatible with the `lz4` CLI.

# Keyword Arguments

- `codec::LZ4HDF5Codec=LZ4HDF5Codec()`
"""
struct LZ4HDF5DecodeOptions <: DecodeOptions
    codec::LZ4HDF5Codec
end
function LZ4HDF5DecodeOptions(;
        codec::LZ4HDF5Codec=LZ4HDF5Codec(),
        kwargs...
    )
    LZ4HDF5DecodeOptions(codec)
end

is_thread_safe(::LZ4HDF5DecodeOptions) = true

function try_find_decoded_size(::LZ4HDF5DecodeOptions, src::AbstractVector{UInt8})::Int64
    if length(src) < 12
        throw(LZ4DecodingError("unexpected end of input"))
    else
        decoded_size = Int64(0)
        for i in 0:7
            decoded_size |= Int64(src[begin+i])<<((7-i)*8)
        end
        if signbit(decoded_size)
            throw(LZ4DecodingError("decoded size is negative"))
        else
            decoded_size
        end
    end
end

function unsafe_load_i32be(src_p::Ptr{UInt8})::Int32
    r = Int32(0)
    for i in 0:3
        r |= Int32(unsafe_load(src_p+i))<<((3-i)*8)
    end
    r
end

function try_decode!(d::LZ4HDF5DecodeOptions, dst::AbstractVector{UInt8}, src::AbstractVector{UInt8}; kwargs...)::MaybeSize
    check_contiguous(dst)
    check_contiguous(src)
    decoded_size::Int64 = try_find_decoded_size(d, src)
    src_size::Int64 = length(src)
    dst_size::Int64 = length(dst)
    if decoded_size > dst_size
        return NOT_SIZE
    end
    cconv_src = Base.cconvert(Ptr{UInt8}, src)
    cconv_dst = Base.cconvert(Ptr{UInt8}, dst)
    GC.@preserve cconv_src cconv_dst begin
        src_p = Base.unsafe_convert(Ptr{UInt8}, cconv_src)
        dst_p = Base.unsafe_convert(Ptr{UInt8}, cconv_dst)
        src_left = src_size
        dst_left = decoded_size
        @assert src_left ≥ 12 # this is checked by try_find_decoded_size
        src_left -= 8
        src_p += 8
        block_size = unsafe_load_i32be(src_p)
        src_left -= 4
        src_p += 4
        if block_size ≤ 0
            throw(LZ4DecodingError("block size must be greater than zero"))
        end
        while dst_left > 0
            local b_size = min(Int64(block_size), dst_left)%Int32
            if src_left < 4
                throw(LZ4DecodingError("unexpected end of input"))
            end
            local c_size = unsafe_load_i32be(src_p)
            src_left -= 4
            src_p += 4
            if c_size ≤ 0
                throw(LZ4DecodingError("block compressed size must be greater than zero"))
            end
            if src_left < c_size
                throw(LZ4DecodingError("unexpected end of input"))
            end
            if c_size == b_size # There was no compression
                @static if VERSION ≥ v"1.10"
                    Libc.memcpy(dst_p, src_p, b_size)
                else
                    unsafe_copyto!(dst_p, src_p, b_size)
                end
            else # do the decompression
                local ret = unsafe_lz4_decompress(src_p, dst_p, c_size, b_size)
                if signbit(ret)
                    throw(LZ4DecodingError("src is malformed"))
                elseif ret != b_size
                    throw(LZ4DecodingError("saved decoded size is not correct"))
                end
            end
            src_left -= c_size
            src_p += c_size
            dst_left -= b_size
            dst_p += b_size
        end
        if !iszero(src_left)
            throw(LZ4DecodingError("unexpected $(src_left) bytes after stream"))
        end
        return decoded_size
    end
end

"""
    struct LZ4FrameEncodeOptions <: EncodeOptions
    LZ4FrameEncodeOptions(; kwargs...)

lz4 frame compression using liblz4: https://lz4.org/

This is the LZ4 Frame (.lz4) format described in https://github.com/lz4/lz4/blob/v1.10.0/doc/lz4_Frame_format.md

This format is compatible with the `lz4` CLI.

# Keyword Arguments

- `codec::LZ4FrameCodec=LZ4FrameCodec()`
- `compressionLevel::Integer=0`: Compression level, 0: default (fast mode); values > $(LZ4_MAX_CLEVEL) count as $(LZ4_MAX_CLEVEL); values < 0 trigger fast acceleration.
- `blockSizeID::Integer=0`: 0: default (max64KB), 4: max64KB, 5: max256KB, 6: max1MB, 7: max4MB;

  The larger the block size, the (slightly) better the compression ratio,
  though there are diminishing returns.
  Larger blocks also increase memory usage on both compression and decompression sides.
- `blockMode::Bool=false`: false: blockLinked, true: blockIndependent;

  Linked blocks sharply reduce inefficiencies when using small blocks, they compress better.
  However, some LZ4 decoders are only compatible with independent blocks.
- `contentChecksumFlag::Bool=false`: A 32-bits checksum of content is written at end of frame.
- `contentSize::Bool=false`: Save size of uncompressed content ; false == unknown.

  If the content size is zero, it will not be saved, even if this option is true due to a
  limitation in liblz4. Ref: https://github.com/lz4/lz4/issues/775
- `blockChecksumFlag::Bool=false`: each block followed by a checksum of block's compressed data.
- `favorDecSpeed::Bool=false`: if true, parser favors decompression speed vs compression ratio. Only works for high compressionLevel (>= LZ4HC_CLEVEL_OPT_MIN)
"""
struct LZ4FrameEncodeOptions <: EncodeOptions
    codec::LZ4FrameCodec
    compressionLevel::Int32
    blockSizeID::Int32
    blockMode::Bool
    contentChecksumFlag::Bool
    contentSize::Bool
    blockChecksumFlag::Bool
    favorDecSpeed::Bool
end
function LZ4FrameEncodeOptions(;
        codec::LZ4FrameCodec=LZ4FrameCodec(),
        compressionLevel::Integer=0,
        blockSizeID::Integer=0,
        blockMode::Bool=false,
        contentChecksumFlag::Bool=false,
        contentSize::Bool=false,
        blockChecksumFlag::Bool=false,
        favorDecSpeed::Bool=false,
        kwargs...
    )
    blockSizeID ∈ (0, 4, 5, 6, 7) || throw(ArgumentError("blockSizeID: $(blockSizeID) must be in (0, 4, 5, 6, 7)"))
    _clamped_compression_level = clamp(compressionLevel, LZ4_MIN_CLEVEL, LZ4_MAX_CLEVEL)
    LZ4FrameEncodeOptions(codec, _clamped_compression_level, blockSizeID, blockMode, contentChecksumFlag, contentSize, blockChecksumFlag, favorDecSpeed)
end

is_thread_safe(::LZ4FrameEncodeOptions) = true

function _preferences(e::LZ4FrameEncodeOptions)::LZ4F_preferences_t
    LZ4F_preferences_t(
        LZ4F_frameInfo_t(
            LZ4F_blockSizeID_t(e.blockSizeID),
            LZ4F_blockMode_t(e.blockMode),
            LZ4F_contentChecksum_t(e.contentChecksumFlag),
            LZ4F_frame,
            Culonglong(e.contentSize), # https://github.com/lz4/lz4/blob/6cf42afbea04c9ea6a704523aead273715001330/lib/lz4frame.c#L446 auto-correct content size if selected (!=0)
            Cuint(0), # no dictID provided
            LZ4F_blockChecksum_t(e.blockChecksumFlag),
        ),
        e.compressionLevel,
        Cuint(0), # autoFlush, this just gets overwritten anyway at https://github.com/lz4/lz4/blob/6cf42afbea04c9ea6a704523aead273715001330/lib/lz4frame.c#L449
        Cuint(e.favorDecSpeed),
        (Cuint(0), Cuint(0), Cuint(0)), # reserved, must be zero
    )
end

function decoded_size_range(::LZ4FrameEncodeOptions)
    # prevent overflow of encode_bound
    # This should be very conservative
    max_size = if sizeof(Csize_t) == 8
        Int64(2)^47 - Int64(2)
    elseif sizeof(Csize_t) == 4
        Int64(2)^31 - Int64(2)
    else
        @assert false "unreachable"
    end
    Int64(0):Int64(1):max_size
end

function encode_bound(e::LZ4FrameEncodeOptions, src_size::Int64)::Int64
    if src_size < 0
        Int64(-1)
    elseif src_size > last(decoded_size_range(e))
        typemax(Int64)
    else
        LZ4F_compressFrameBound(Csize_t(src_size), _preferences(e))
    end
end

function try_encode!(e::LZ4FrameEncodeOptions, dst::AbstractVector{UInt8}, src::AbstractVector{UInt8}; kwargs...)::MaybeSize
    check_contiguous(dst)
    check_contiguous(src)
    src_size::Int64 = length(src)
    dst_size::Int64 = length(dst)
    check_in_range(decoded_size_range(e); src_size)
    # LZ4F_compressFrame needs this to hold.
    if dst_size < encode_bound(e, src_size)
        return NOT_SIZE
    end
    ret = LZ4F_compressFrame(dst, src, _preferences(e))
    if LZ4F_isError(ret)
        error("unexpected LZ4F error: $(LZ4F_getErrorName(ret))")
    else
        Int64(ret)
    end
end

"""
    struct LZ4BlockEncodeOptions <: EncodeOptions
    LZ4BlockEncodeOptions(; kwargs...)

lz4 block compression using liblz4: https://lz4.org/

This is the LZ4 Block format described in https://github.com/lz4/lz4/blob/v1.10.0/doc/lz4_Block_format.md

This format has no framing layer and is NOT compatible with the `lz4` CLI.

There is also a maximum decoded size of about 2 GB for this implementation.

# Keyword Arguments

- `codec::LZ4BlockCodec=LZ4BlockCodec()`
- `compressionLevel::Integer=0`: Compression level, 0: default (fast mode); values > $(LZ4_MAX_CLEVEL) count as $(LZ4_MAX_CLEVEL); values < 0 trigger fast acceleration.
"""
struct LZ4BlockEncodeOptions <: EncodeOptions
    codec::LZ4BlockCodec
    compressionLevel::Int32
end
function LZ4BlockEncodeOptions(;
        codec::LZ4BlockCodec=LZ4BlockCodec(),
        compressionLevel::Integer=0,
        kwargs...
    )
    _clamped_compression_level = clamp(compressionLevel, LZ4_MIN_CLEVEL, LZ4_MAX_CLEVEL)
    LZ4BlockEncodeOptions(codec, _clamped_compression_level)
end

is_thread_safe(::LZ4BlockEncodeOptions) = true

decoded_size_range(::LZ4BlockEncodeOptions) = Int64(0):Int64(1):LZ4_MAX_INPUT_SIZE

function encode_bound(::LZ4BlockEncodeOptions, src_size::Int64)::Int64
    if src_size > LZ4_MAX_INPUT_SIZE
        typemax(Int64)
    else
        unsafe_lz4_compressbound(src_size)
    end
end

function try_encode!(e::LZ4BlockEncodeOptions, dst::AbstractVector{UInt8}, src::AbstractVector{UInt8}; kwargs...)::MaybeSize
    check_contiguous(dst)
    check_contiguous(src)
    src_size::Int64 = length(src)
    dst_size::Int64 = length(dst)
    check_in_range(decoded_size_range(e); src_size)
    if dst_size < 1
        return NOT_SIZE
    end
    # src_size must fit in an Int32 because it is in decoded_size_range(e)
    src_size32 = Int32(src_size)
    cconv_src = Base.cconvert(Ptr{UInt8}, src)
    cconv_dst = Base.cconvert(Ptr{UInt8}, dst)
    ret = GC.@preserve cconv_src cconv_dst begin
        src_p = Base.unsafe_convert(Ptr{UInt8}, cconv_src)
        dst_p = Base.unsafe_convert(Ptr{UInt8}, cconv_dst)
        unsafe_lz4_compress(src_p, dst_p, src_size32, clamp(dst_size, Int32), e.compressionLevel)
    end
    if iszero(ret)
        NOT_SIZE
    else
        Int64(ret)
    end
end

"""
    struct LZ4NumcodecsEncodeOptions <: EncodeOptions
    LZ4NumcodecsEncodeOptions(; kwargs...)

lz4 numcodecs style compression using liblz4: https://lz4.org/

This is the [`LZ4BlockCodec`](@ref) format with a 4-byte header containing the
size of the decoded data as a little-endian 32-bit signed integer.

This format is documented in https://numcodecs.readthedocs.io/en/stable/compression/lz4.html

This format is NOT compatible with the `lz4` CLI.

There is also a maximum decoded size of about 2 GB for this implementation.

# Keyword Arguments

- `codec::LZ4NumcodecsCodec=LZ4NumcodecsCodec()`
- `compressionLevel::Integer=0`: Compression level, 0: default (fast mode); values > $(LZ4_MAX_CLEVEL) count as $(LZ4_MAX_CLEVEL); values < 0 trigger fast acceleration.
"""
struct LZ4NumcodecsEncodeOptions <: EncodeOptions
    codec::LZ4NumcodecsCodec
    compressionLevel::Int32
end
function LZ4NumcodecsEncodeOptions(;
        codec::LZ4NumcodecsCodec=LZ4NumcodecsCodec(),
        compressionLevel::Integer=0,
        kwargs...
    )
    _clamped_compression_level = clamp(compressionLevel, LZ4_MIN_CLEVEL, LZ4_MAX_CLEVEL)
    LZ4NumcodecsEncodeOptions(codec, _clamped_compression_level)
end

is_thread_safe(::LZ4NumcodecsEncodeOptions) = true

decoded_size_range(::LZ4NumcodecsEncodeOptions) = Int64(0):Int64(1):LZ4_MAX_INPUT_SIZE

function encode_bound(::LZ4NumcodecsEncodeOptions, src_size::Int64)::Int64
    if src_size > LZ4_MAX_INPUT_SIZE
        typemax(Int64)
    else
        unsafe_lz4_compressbound(src_size) + Int64(4)
    end
end

function try_encode!(e::LZ4NumcodecsEncodeOptions, dst::AbstractVector{UInt8}, src::AbstractVector{UInt8}; kwargs...)::MaybeSize
    check_contiguous(dst)
    check_contiguous(src)
    src_size::Int64 = length(src)
    dst_size::Int64 = length(dst)
    check_in_range(decoded_size_range(e); src_size)
    if dst_size < 5
        return NOT_SIZE
    end
    # src_size must fit in an Int32 because it is in decoded_size_range(e)
    src_size32 = Int32(src_size)
    cconv_src = Base.cconvert(Ptr{UInt8}, src)
    cconv_dst = Base.cconvert(Ptr{UInt8}, dst)
    ret = GC.@preserve cconv_src cconv_dst begin
        src_p = Base.unsafe_convert(Ptr{UInt8}, cconv_src)
        dst_p = Base.unsafe_convert(Ptr{UInt8}, cconv_dst)
        for i in 0:3
            unsafe_store!(dst_p+i, (src_size32>>>(i*8))%UInt8)
        end
        dst_size -= 4
        dst_p += 4
        unsafe_lz4_compress(src_p, dst_p, src_size32, clamp(dst_size, Int32), e.compressionLevel)
    end
    if iszero(ret)
        NOT_SIZE
    else
        Int64(ret) + Int64(4)
    end
end


"""
    struct LZ4HDF5EncodeOptions <: EncodeOptions
    LZ4HDF5EncodeOptions(; kwargs...)

LZ4 HDF5 format compression using liblz4: https://lz4.org/

This is the LZ4 HDF5 format used in HDF5 Filter ID: 32004.

This format is documented in https://github.com/HDFGroup/hdf5_plugins

This format is NOT compatible with the `lz4` CLI.

# Keyword Arguments

- `codec::LZ4HDF5Codec=LZ4HDF5Codec()`
- `compressionLevel::Integer=0`: Compression level, 0: default (fast mode); values > $(LZ4_MAX_CLEVEL) count as $(LZ4_MAX_CLEVEL); values < 0 trigger fast acceleration.
- `blockSize::Integer=2^30`: Decompressed bytes per block. Must be in `1:$(LZ4_MAX_INPUT_SIZE)`.
"""
struct LZ4HDF5EncodeOptions <: EncodeOptions
    codec::LZ4HDF5Codec
    compressionLevel::Int32
    blockSize::Int32
end
function LZ4HDF5EncodeOptions(;
        codec::LZ4HDF5Codec=LZ4HDF5Codec(),
        compressionLevel::Integer=0,
        blockSize::Integer=2^30,
        kwargs...
    )
    check_in_range(1:LZ4_MAX_INPUT_SIZE; blockSize)
    _clamped_compression_level = clamp(compressionLevel, LZ4_MIN_CLEVEL, LZ4_MAX_CLEVEL)
    LZ4HDF5EncodeOptions(codec, _clamped_compression_level, blockSize)
end

is_thread_safe(::LZ4HDF5EncodeOptions) = true

# Prevent encode_bound reaching typemax(Int64) if blockSize is 1
decoded_size_range(e::LZ4HDF5EncodeOptions) = Int64(0):Int64(1):Int64(1844674407370955155)

function encode_bound(e::LZ4HDF5EncodeOptions, src_size::Int64)::Int64
    if src_size > last(decoded_size_range(e))
        typemax(Int64)
    else
        block_size = clamp(src_size, Int64(1), Int64(e.blockSize))
        nblocks = cld(src_size, block_size)
        lz4_scratch_space = block_size÷Int64(255) + Int64(16)
        src_size + Int64(4)*nblocks + lz4_scratch_space + Int64(12)
    end
end

function try_encode!(e::LZ4HDF5EncodeOptions, dst::AbstractVector{UInt8}, src::AbstractVector{UInt8}; kwargs...)::MaybeSize
    check_contiguous(dst)
    check_contiguous(src)
    src_size::Int64 = length(src)
    dst_size::Int64 = length(dst)
    check_in_range(decoded_size_range(e); src_size)
    block_size = clamp(src_size, Int64(1), Int64(e.blockSize))
    if dst_size < 12
        return NOT_SIZE
    end
    cconv_src = Base.cconvert(Ptr{UInt8}, src)
    cconv_dst = Base.cconvert(Ptr{UInt8}, dst)
    GC.@preserve cconv_src cconv_dst begin
        src_p = Base.unsafe_convert(Ptr{UInt8}, cconv_src)
        dst_p = Base.unsafe_convert(Ptr{UInt8}, cconv_dst)
        src_left = src_size
        dst_left = dst_size
        # Store original size as big endian signed 64 bit
        for i in 0:7
            unsafe_store!(dst_p+i, (src_size>>>((7-i)*8))%UInt8)
        end
        dst_left -= 8
        dst_p += 8
        # Store block size as big endian signed 32 bit
        for i in 0:3
            unsafe_store!(dst_p+i, (block_size>>>((3-i)*8))%UInt8)
        end
        dst_left -= 4
        dst_p += 4
        while src_left > 0
            if dst_left < 5
                return NOT_SIZE
            end
            local b_size = min(src_left, block_size)%Int32
            @assert !iszero(b_size)
            local c_size_p = dst_p
            dst_left -= 4
            dst_p += 4
            local ret = unsafe_lz4_compress(src_p, dst_p, b_size, clamp(dst_left, Int32), e.compressionLevel)
            # Store the data directly if there was no compression
            # iszero(ret) indicates that dst_left was too small for compression.
            # but it might be large enough for a copy.
            local c_size = if ret ≥ b_size || iszero(ret)
                if dst_left < b_size
                    return NOT_SIZE
                end
                @static if VERSION ≥ v"1.10"
                    Libc.memcpy(dst_p, src_p, b_size)
                else
                    unsafe_copyto!(dst_p, src_p, b_size)
                end
                b_size
            else
                ret
            end
            # Store block compressed size as big endian signed 32 bit
            for i in 0:3
                unsafe_store!(c_size_p+i, (c_size>>>((3-i)*8))%UInt8)
            end
            dst_left -= c_size
            dst_p += c_size
            src_left -= b_size
            src_p += b_size
        end
        return dst_size - dst_left
    end
end

using ChunkCodecCore: encode_bound, decoded_size_range, encode, decode, DecodedSizeError
using ChunkCodecLibLz4
using ChunkCodecTests: test_codec
using Test: @testset, @test_throws, @test

@testset "default" begin
    test_codec(LZ4BlockCodec(), LZ4BlockEncodeOptions(), LZ4BlockDecodeOptions(); trials = 100)
end
@testset "compressionLevel options" begin
    # Compression level is clamped
    for compressionLevel in [typemin(Int128); -30:13; typemax(Int128)]
        test_codec(
            LZ4BlockCodec(),
            LZ4BlockEncodeOptions(; compressionLevel),
            LZ4BlockDecodeOptions();
            trials=3,
        )
    end
end
@testset "unexpected eof" begin
    e = LZ4BlockEncodeOptions()
    d = LZ4BlockDecodeOptions()
    u = [0x00, 0x01, 0x02]
    c = encode(e, u)
    @test decode(d, c) == u
    for i in 1:length(c)
        @test_throws LZ4DecodingError("unexpected end of input") decode(d, c[1:i-1])
    end
    @test_throws LZ4DecodingError("offset is before the beginning of the output") decode(d, u)
end
@testset "dry_run_block_decode tests" begin
    f = ChunkCodecLibLz4.dry_run_block_decode
    d = LZ4BlockDecodeOptions()
    e = LZ4BlockEncodeOptions()

    @testset "zero and one byte cases" begin
        @test_throws LZ4DecodingError("unexpected end of input") f(UInt8[])
        @test encode(e, UInt8[]) == [0x00]
        @test f([0x00]) == 0
        for i in 0x01:0x0F
            @test_throws LZ4DecodingError("end of block condition 1 violated") f([i])
        end
        for i in 0x10:0xFF
            @test_throws LZ4DecodingError("unexpected end of input") f([i])
        end
    end
    @testset "two byte cases" begin
        for b0 in 0x00:0x0F
            for b1 in 0x00:0xFF
                @test_throws LZ4DecodingError("unexpected end of input") f([b0, b1])
            end
        end
        b0 = 0x10
        for b1 in 0x00:0xFF
            @test f([b0, b1]) == 1
        end
        for b0 in 0x11:0x1F
            for b1 in 0x00:0xFF
                @test_throws LZ4DecodingError("end of block condition 1 violated") f([b0, b1])
            end
        end
        for b0 in 0x20:0xFF
            for b1 in 0x00:0xFF
                @test_throws LZ4DecodingError("unexpected end of input") f([b0, b1])
            end
        end
    end
    @testset "max decoded size" begin
        max_cint_zeros = UInt8[0x1F;0x00;0x01;0x00;fill(0xFF,8421504);0x66;0x50;fill(0x00,5)]
        over_max_cint_zeros = UInt8[0x1F;0x00;0x01;0x00;fill(0xFF,8421504);0x67;0x50;fill(0x00,5)]
        @test f(max_cint_zeros) == typemax(Cint)
        @test f(over_max_cint_zeros) == Int64(typemax(Cint))+1
        @test_throws(
            LZ4DecodingError("actual decoded size > typemax(Int32): 2147483648 > 2147483647"),
            decode(d, over_max_cint_zeros; max_size=Int64(2)^24),
        )
        @test_throws(
            DecodedSizeError,
            decode(d, max_cint_zeros; max_size=Int64(2)^24),
        )
        @test_throws LZ4DecodingError("actual decoded size > typemax(Int32): 2147483648 > 2147483647") decode(d, over_max_cint_zeros)
    end
    @testset "end of block condition 2 and 3" begin
        # decode starts at 12 from end with length 7
        # https://github.com/lz4/lz4/issues/1495#issuecomment-2307679190
        c = UInt8[0x13;0xaa;0x01;0x00;0x50;fill(0xbb,5)]
        @test f(c) == 13
        @test decode(d, c; size_hint=Int64(13)) == [fill(0xaa, 8); fill(0xbb, 5)]

        # match starts starts at 12 from end with length 8
        c = UInt8[0x14;0xaa;0x01;0x00;0x40;fill(0xbb,4)]
        @test_throws LZ4DecodingError("end of block condition 2 violated") f(c)
        @test_throws LZ4DecodingError("end of block condition 2 violated") decode(d, c; size_hint=Int64(13))

        # match starts starts at 11 from end with length 6
        c = UInt8[0x12;0xaa;0x01;0x00;0x50;fill(0xbb,5)]
        @test_throws LZ4DecodingError("end of block condition 3 violated") f(c)
        @test_throws LZ4DecodingError("end of block condition 3 violated") decode(d, c; size_hint=Int64(12))

        # match starts at 9 from end
        c = UInt8[0x10;0xaa;0x01;0x00;0x50;fill(0xbb,5)]
        @test_throws LZ4DecodingError("end of block condition 3 violated") f(c)

        # match starts 11 from end with length 6 but offset 2
        c = UInt8[0x22;0xaa;0xaa;0x02;0x00;0x50;fill(0xbb,5)]
        @test_throws LZ4DecodingError("end of block condition 3 violated") f(c) == 13
        @test_throws LZ4DecodingError("end of block condition 3 violated") decode(d, c; size_hint=Int64(13))
    end
    @testset "errors reading offset" begin
        c = UInt8[0x13;0xaa;0x00;]
        @test_throws LZ4DecodingError("unexpected end of input") f(c)

        c = UInt8[0x13;0xaa;0x00;0x00;]
        @test_throws LZ4DecodingError("zero offset value found") f(c)

        c = UInt8[0x13;0xaa;0x02;0x00;0x50;fill(0xbb,5)]
        @test_throws LZ4DecodingError("offset is before the beginning of the output") f(c)
        @test_throws LZ4DecodingError("offset is before the beginning of the output") decode(d, c; size_hint=Int64(100))

        c = UInt8[0x13;0xaa;0x01;0x00; 0x03;0x02;0x00; 0x50;fill(0xbb,5)]
        @test f(c) == 20
        @test decode(d, c; size_hint=Int64(21)) == [fill(0xaa, 15); fill(0xbb,5);]

        c = UInt8[0x10;0xaa;0x01;0x00; 0x03;0x05;0x00; 0x50;fill(0xbb,5)]
        @test f(c) == 17
        @test decode(d, c; size_hint=Int64(17)) == [fill(0xaa, 12); fill(0xbb,5);]

        c = UInt8[0x10;0xaa;0x01;0x00; 0x03;0x06;0x00; 0x50;fill(0xbb,5)]
        @test_throws LZ4DecodingError("offset is before the beginning of the output") f(c)
        @test_throws LZ4DecodingError("offset is before the beginning of the output") decode(d, c; size_hint=Int64(100))
    end
    @testset "error reading matchlength" begin
        c = UInt8[0x10;0xaa;0x01;0x00; 0x0F;0x01;0x00;]
        @test_throws LZ4DecodingError("unexpected end of input") f(c)
        @test_throws LZ4DecodingError("unexpected end of input") decode(d, c; size_hint=Int64(1000))

        c = UInt8[0x10;0xaa;0x01;0x00; 0x0F;0x01;0x00;0xFF]
        @test_throws LZ4DecodingError("unexpected end of input") f(c)
        @test_throws LZ4DecodingError("unexpected end of input") decode(d, c; size_hint=Int64(1000))
    end
    @testset "exercise offsets" begin
        thing = rand(UInt8, 200)
        u = UInt8[]
        for dist in [0:258; 1000:1030; 2000:1000:33000; 34000:10000:100_000]
            append!(u, thing)
            append!(u, rand(0x00:0x0f, dist))
        end
        c = encode(e, u)
        @test f(c) == length(u)
        @test decode(d, c) == u

        for n in 65536-300:65536
            u = [thing; zeros(UInt8, n); thing]
            c = encode(e, u)
            @test f(c) == length(u)
            @test decode(d, c) == u
        end
    end
end

using ChunkCodecCore: encode_bound, decoded_size_range, encode, decode, DecodedSizeError, MaybeSize
using ChunkCodecLibLz4
using ChunkCodecTests: test_codec
using Test: @testset, @test_throws, @test

@testset "default" begin
    test_codec(LZ4NumcodecsCodec(), LZ4NumcodecsEncodeOptions(), LZ4NumcodecsDecodeOptions(); trials=100)
end
@testset "compressionLevel options" begin
    # Compression level is clamped
    for compressionLevel in [typemin(Int128); -30:13; typemax(Int128)]
        test_codec(
            LZ4NumcodecsCodec(),
            LZ4NumcodecsEncodeOptions(; compressionLevel),
            LZ4NumcodecsDecodeOptions();
            trials=3,
        )
    end
end
@testset "unexpected eof" begin
    e = LZ4NumcodecsEncodeOptions()
    d = LZ4NumcodecsDecodeOptions()
    u = [0x00, 0x01, 0x02]
    c = encode(e, u)
    @test decode(d, c) == u
    for i in 1:length(c)
        @test_throws LZ4DecodingError decode(d, c[1:i-1])
    end
    @test_throws LZ4DecodingError decode(d, u)
end
@testset "incorrect decoded size" begin
    e = LZ4NumcodecsEncodeOptions()
    d = LZ4NumcodecsDecodeOptions()
    c = [0xFF, 0xFF, 0xFF, 0xFF, 0x00]
    @test_throws LZ4DecodingError("decoded size is negative") decode(d, c)

    c = [0x00, 0x00, 0x00, 0x80, 0x00]
    @test_throws LZ4DecodingError("decoded size is negative") decode(d, c)

    c = [0x01, 0x00, 0x00, 0x00, 0x00]
    @test_throws LZ4DecodingError("saved decoded size is not correct") decode(d, c)

    c = [0x01, 0x00, 0x00, 0x00, 0x10, 0xaa]
    @test decode(d, c) == [0xaa]
end
@testset "max decoded size" begin
    d = LZ4NumcodecsDecodeOptions()
    c = UInt8[0xFF;0xFF;0xFF;0x7F; 0x1F;0x00;0x01;0x00;fill(0xFF,8421504);0x66;0x50;fill(0x00,5)]
    @test_throws DecodedSizeError(2^24, MaybeSize(-typemax(Int32))) decode(d, c; max_size=Int64(2)^24)
end

# Constants and c wrapper functions ported to Julia from lz4.h and lz4hc.h
# https://github.com/lz4/lz4/blob/v1.10.0/lib/lz4.h
# https://github.com/lz4/lz4/blob/v1.10.0/lib/lz4hc.h

const LZ4HC_CLEVEL_MIN      =  Int32(2)
const LZ4HC_CLEVEL_DEFAULT  =  Int32(9)
const LZ4HC_CLEVEL_OPT_MIN  = Int32(10)
const LZ4HC_CLEVEL_MAX      = Int32(12)

# Note this is in lz4.c but I'm not sure why
const LZ4_ACCELERATION_MAX = Int32(65537)

const LZ4_MAX_INPUT_SIZE = Int64(0x7E000000)

const LZ4_MIN_CLEVEL = Int32(-(LZ4_ACCELERATION_MAX - Int32(1)))
const LZ4_MAX_CLEVEL = Int32(LZ4HC_CLEVEL_MAX)

# LZ4_COMPRESSBOUND assuming `src_size` is in 0:LZ4_MAX_INPUT_SIZE
function unsafe_lz4_compressbound(src_size::Int64)
    src_size + src_size÷Int64(255) + Int64(16)
end

# Combination of LZ4_compress_fast and LZ4_compress_HC
# Returns the number of bytes written to `dst` or 0 if compression fails.
function unsafe_lz4_compress(src::Ptr{UInt8}, dst::Ptr{UInt8}, src_size::Int32, dst_size::Int32, level::Int32)::Int32
    if level < LZ4HC_CLEVEL_MIN
        # Fast mode 
        # Convert level to acceleration using
        # int const acceleration = (level < 0) ? -level + 1 : 1;
        # from:
        # https://github.com/lz4/lz4/blob/6cf42afbea04c9ea6a704523aead273715001330/lib/lz4frame.c#L913
        acceleration = if level < 0
            -level + Int32(1)
        else
            Int32(1)
        end
        ccall(
            (:LZ4_compress_fast, liblz4), Cint,
            (Ptr{UInt8}, Ptr{UInt8}, Cint, Cint, Cint),
            src, dst, src_size, dst_size, acceleration
        )
    else
        # HC mode
        # level is normal
        ccall(
            (:LZ4_compress_HC, liblz4), Cint,
            (Ptr{UInt8}, Ptr{UInt8}, Cint, Cint, Cint),
            src, dst, src_size, dst_size, level
        )
    end
end

# Returns the number of bytes written to `dst` or a negative if decompression fails.
function unsafe_lz4_decompress(src::Ptr{UInt8}, dst::Ptr{UInt8}, src_size::Int32, dst_size::Int32)::Int32
    ccall(
        (:LZ4_decompress_safe, liblz4), Cint,
        (Ptr{UInt8}, Ptr{UInt8}, Cint, Cint),
        src, dst, src_size, dst_size
    )
end

# The following is the original license info from lz4.h and lz4hc.h

#=
 *  LZ4 - Fast LZ compression algorithm
 *  Header File
 *  Copyright (C) 2011-2023, Yann Collet.

   BSD 2-Clause License (http://www.opensource.org/licenses/bsd-license.php)

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
       * Redistributions in binary form must reproduce the above
   copyright notice, this list of conditions and the following disclaimer
   in the documentation and/or other materials provided with the
   distribution.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

   You can contact the author at :
    - LZ4 homepage : http://www.lz4.org
    - LZ4 source repository : https://github.com/lz4/lz4
=#

#=
   LZ4 HC - High Compression Mode of LZ4
   Header File
   Copyright (C) 2011-2020, Yann Collet.
   BSD 2-Clause License (http://www.opensource.org/licenses/bsd-license.php)

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
       * Redistributions in binary form must reproduce the above
   copyright notice, this list of conditions and the following disclaimer
   in the documentation and/or other materials provided with the
   distribution.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

   You can contact the author at :
   - LZ4 source repository : https://github.com/lz4/lz4
   - LZ4 public forum : https://groups.google.com/forum/#!forum/lz4c
=#

using Random: Random
using ChunkCodecLibLz4
using Test: @testset, @test_throws, @test
using Aqua: Aqua

Aqua.test_all(ChunkCodecLibLz4; persistent_tasks = false)

Random.seed!(1234)
@testset "frame" begin
    include("frame.jl")
end
@testset "block" begin
    include("block.jl")
end
@testset "numcodecs" begin
    include("numcodecs.jl")
end
@testset "hdf5" begin
    include("hdf5.jl")
end
@testset "errors" begin
    @test sprint(Base.showerror, LZ4DecodingError("test message")) ==
        "LZ4DecodingError: test message"
end

# This file contains tests that require a large amount of memory (at least 15 GB)
# and take a long time to run. The tests are designed to check the 
# compression and decompression functionality of the ChunkCodecLibLz4 package 
# with very large inputs. These tests are not run with CI


using ChunkCodecLibLz4:
    ChunkCodecLibLz4,
    LZ4BlockCodec,
    LZ4BlockEncodeOptions,
    LZ4NumcodecsCodec,
    LZ4NumcodecsEncodeOptions,
    encode,
    decode,
    LZ4DecodingError
using ChunkCodecCore:
    decoded_size_range
using Test: @testset, @test, @test_throws
using Random

@testset "Big Memory Tests" begin
    Sys.WORD_SIZE == 64 || error("tests require 64 bit word size")
    @testset "try to decode over typemax(Int32) bytes" begin
        @test_throws LZ4DecodingError("encoded size is larger than `typemax(Int32)`") decode(LZ4BlockCodec(), zeros(UInt8, 2^31))
        @test_throws LZ4DecodingError("encoded size is larger than `typemax(Int32) + 4`") decode(LZ4NumcodecsCodec(), zeros(UInt8, 2^31+4))
        let
            # Design an input that is exactly length `typemax(Int32)`
            # [0xF0; fill(0xFF, N); Y; fill(junk, M);]
            # L = 2 + N + M
            # M = 15 + 255*N + Y
            # L = 17 + 256*N + Y
            # N = 8388607, Y = 238, L = typemax(Int32)
            local N = 8388607
            local Y = 238
            local M = 15 + 255*N + Y
            local max_encoded = [0xF0; fill(0xFF, N); UInt8(Y); fill(0x42, M);]
            @test decode(LZ4BlockCodec(), max_encoded) == fill(0x42, M)
            @test decode(LZ4NumcodecsCodec(), [reinterpret(NTuple{4, UInt8}, htol(Int32(M)))...; max_encoded]) == fill(0x42, M)
        end
    end
    @testset "max decoded size" begin
        let
            local max_cint_zeros = UInt8[0x1F;0x00;0x01;0x00;fill(0xFF,8421504);0x66;0x50;fill(0x00,5)]
            local m = last(decoded_size_range(LZ4BlockEncodeOptions()))
            local input = zeros(UInt8, m)
            for i in m:-1:m-16
                local c = encode(LZ4BlockEncodeOptions(), @view(input[1:i]))
                @test ChunkCodecLibLz4.dry_run_block_decode(c) == i
            end
            local out = decode(LZ4BlockCodec(), max_cint_zeros)
            @test all(iszero, out)
            @test length(out) == typemax(Cint)
            
            input = rand(UInt8, m)
            local c = encode(LZ4BlockEncodeOptions(), input)
            @test ChunkCodecLibLz4.dry_run_block_decode(c) == m
            @test decode(LZ4BlockCodec(), c) == input

            c = encode(LZ4NumcodecsEncodeOptions(), input)
            @test decode(LZ4NumcodecsCodec(), c) == input
            c = UInt8[0xFF;0xFF;0xFF;0x7F; 0x1F;0x00;0x01;0x00;fill(0xFF,8421504);0x66;0x50;fill(0x00,5)]
            out = decode(LZ4NumcodecsCodec(), c)
            @test all(iszero, out)
            @test length(out) == typemax(Cint)
        end
    end
end

module ChunkCodecLibLz4

using Lz4_jll: liblz4

using ChunkCodecCore:
    Codec,
    EncodeOptions,
    DecodeOptions,
    check_contiguous,
    check_in_range,
    grow_dst!,
    DecodingError,
    MaybeSize,
    NOT_SIZE
import ChunkCodecCore:
    decode_options,
    can_concatenate,
    try_decode!,
    try_resize_decode!,
    try_encode!,
    encode_bound,
    is_thread_safe,
    try_find_decoded_size,
    decoded_size_range

export LZ4FrameCodec,
    LZ4FrameEncodeOptions,
    LZ4FrameDecodeOptions,
    LZ4BlockCodec,
    LZ4BlockEncodeOptions,
    LZ4BlockDecodeOptions,
    LZ4NumcodecsCodec,
    LZ4NumcodecsEncodeOptions,
    LZ4NumcodecsDecodeOptions,
    LZ4HDF5Codec,
    LZ4HDF5EncodeOptions,
    LZ4HDF5DecodeOptions,
    LZ4DecodingError

# reexport ChunkCodecCore
using ChunkCodecCore: ChunkCodecCore, encode, decode
export ChunkCodecCore, encode, decode


include("liblz4.jl")
include("liblz4frame.jl")

"""
    struct LZ4FrameCodec <: Codec
    LZ4FrameCodec()

LZ4 frame compression using liblz4: https://lz4.org/

This is the LZ4 Frame (.lz4) format described in https://github.com/lz4/lz4/blob/v1.10.0/doc/lz4_Frame_format.md

This format is compatible with the `lz4` CLI.

Encode compresses data as a single frame.
Decoding will succeed even if the decompressed size is unknown.
Decoding accepts concatenated frames 
and will error if there is invalid data appended.

See also [`LZ4FrameEncodeOptions`](@ref) and [`LZ4FrameDecodeOptions`](@ref)
"""
struct LZ4FrameCodec <: Codec
end
decode_options(::LZ4FrameCodec) = LZ4FrameDecodeOptions() # default decode options

"""
    struct LZ4BlockCodec <: Codec
    LZ4BlockCodec()

lz4 block compression using liblz4: https://lz4.org/

This is the LZ4 Block format described in https://github.com/lz4/lz4/blob/v1.10.0/doc/lz4_Block_format.md

This format has no framing layer and is NOT compatible with the `lz4` CLI.

Decoding requires the encoded size to be at most `typemax(Int32)`.

There is also a maximum decoded size of about 2 GB for this implementation.

See also [`LZ4BlockEncodeOptions`](@ref) and [`LZ4BlockDecodeOptions`](@ref)
"""
struct LZ4BlockCodec <: Codec
end
decode_options(::LZ4BlockCodec) = LZ4BlockDecodeOptions() # default decode options

"""
    struct LZ4NumcodecsCodec <: Codec
    LZ4NumcodecsCodec()

lz4 numcodecs style compression using liblz4: https://lz4.org/

This is the [`LZ4BlockCodec`](@ref) format with a 4-byte header containing the
size of the decoded data as a little-endian 32-bit signed integer.

This format is documented in https://numcodecs.readthedocs.io/en/stable/compression/lz4.html

This format is NOT compatible with the `lz4` CLI.

Decoding requires the encoded size to be at most `typemax(Int32) + 4`.

There is also a maximum decoded size of about 2 GB for this implementation.

See also [`LZ4NumcodecsEncodeOptions`](@ref) and [`LZ4NumcodecsDecodeOptions`](@ref)
"""
struct LZ4NumcodecsCodec <: Codec
end
decode_options(::LZ4NumcodecsCodec) = LZ4NumcodecsDecodeOptions() # default decode options

"""
    struct LZ4HDF5Codec <: Codec
    LZ4HDF5Codec()

LZ4 HDF5 format compression using liblz4: https://lz4.org/

This is the LZ4 HDF5 format used in HDF5 Filter ID: 32004.

This format is documented in https://github.com/HDFGroup/hdf5_plugins

This format is NOT compatible with the `lz4` CLI.

See also [`LZ4HDF5EncodeOptions`](@ref) and [`LZ4HDF5DecodeOptions`](@ref)
"""
struct LZ4HDF5Codec <: Codec
end
decode_options(::LZ4HDF5Codec) = LZ4HDF5DecodeOptions() # default decode options

include("encode.jl")
include("decode.jl")

end # module ChunkCodecLibLz4
